Subject: Base validators are built incorrectly
Description
When a base validator is built, any property that
    -  has a @validate annotations
    -  or holds a class for which a base validator exists

gets a validator attached. Then any custom validator for a class is added.

Currently this is not working as expected. Consider this example:

class Node {

    /**
     * Workspace this node is contained in
     *
     * @var \F3\TYPO3CR\Domain\Model\Workspace
     */
    protected $workspace;

    /**
     * Identifier of this node which is unique within its workspace
     *
     * @var string
     * @validate uuid
     */
    protected $identifier;

This will check the $identifier to be an UUID and it will also check validity on $workspace (if the validator for that is not NULL). But if
the uuid validation annotation is removed the $workspace property will no longer be validated as well.

Associated revisions
Revision 48baedce - 2010-09-22 17:51 - Karsten Dambekalns

[+BUGFIX] FLOW3 (Validation): Fix building of base validators

The conjunction validators built for base validation of models did not
behave correctly, validation of contained objects was not added at all,
if no @validate annotation was found (#9862).

In addition validators for nested objects (A contains B which contains

2015-08-03 1/3



A) could not be built due to ending up in endless recursion (#9855).

Change-Id: Id62828271312adb5c8e21c000a061b008b4596ec
Fixes: #9855
Fixes: #9862

Revision 905f0e34 - 2010-10-08 12:51 - Karsten Dambekalns

[+BUGFIX] FLOW3 (Validation): Only build base validator for prototypes

The ValidatorResolver built a base validator conjunction for all
properties in a class, but it should do that only for prototypes (and
thus skip things like the object manager).

Change-Id: I386a06199c7d63cf152389a9463dc54451a7f575
Fixes: #9862

History
#1 - 2010-09-21 21:58 - Karsten Dambekalns
- Status changed from Needs Feedback to Accepted

#2 - 2010-09-22 10:03 - Karsten Dambekalns
- Status changed from Accepted to Under Review

#3 - 2010-09-24 09:00 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:"48baedceea717f40bd195df3469cbee64d3a3acd".

#4 - 2010-09-28 00:29 - Sebastian Kurfuerst
- Status changed from Resolved to Accepted
- % Done changed from 100 to 50

Hey Karsten,

we have just found a severe regression with this patch:

In the BlogExample, the "Blog" object holds a reference to the "PostRepository" -- and now, a validator is built for the PostRepository, even though it is
a SINGLETON object.

This should never happen for singletons IMHO, they should not be mappable at all by the propery mapper, but only injected via DI.

Greets,
Bastian, Andi and Sebastian :-)

#5 - 2010-09-28 16:30 - Karsten Dambekalns
This should never happen for singletons IMHO, they should not be mappable at all by the propery mapper, but only injected via DI.

Well, is it singletons or should validators only be built for entities and value objects?

#6 - 2010-09-28 16:38 - Sebastian Kurfuerst

I'd say only for entities / value objects.

#7 - 2010-09-29 11:05 - Karsten Dambekalns
- Status changed from Accepted to Under Review

http://review.typo3.org/137

#8 - 2010-10-08 13:00 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 50 to 100

Applied in changeset commit:"905f0e347e3c2bf5fbb673d94a97703f8dd925b0".
